(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('angular-resize-event', ['exports', '@angular/core'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['angular-resize-event'] = {}, global.ng.core));
}(this, (function (exports, i0) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);

    var ResizedEvent = /** @class */ (function () {
        function ResizedEvent(newRect, oldRect) {
            this.newRect = newRect;
            this.oldRect = oldRect;
            this.isFirst = oldRect == null;
        }
        return ResizedEvent;
    }());

    var ResizedDirective = /** @class */ (function () {
        function ResizedDirective(element, zone) {
            var _this = this;
            this.element = element;
            this.zone = zone;
            this.resized = new i0.EventEmitter();
            this.observer = new ResizeObserver(function (entries) { return _this.zone.run(function () { return _this.observe(entries); }); });
        }
        ResizedDirective.prototype.ngOnInit = function () {
            this.observer.observe(this.element.nativeElement);
        };
        ResizedDirective.prototype.ngOnDestroy = function () {
            this.observer.disconnect();
        };
        ResizedDirective.prototype.observe = function (entries) {
            var domSize = entries[0];
            var resizedEvent = new ResizedEvent(domSize.contentRect, this.oldRect);
            this.oldRect = domSize.contentRect;
            this.resized.emit(resizedEvent);
        };
        return ResizedDirective;
    }());
    ResizedDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.6", ngImport: i0__namespace, type: ResizedDirective, deps: [{ token: i0__namespace.ElementRef }, { token: i0__namespace.NgZone }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    ResizedDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.6", type: ResizedDirective, selector: "[resized]", outputs: { resized: "resized" }, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.6", ngImport: i0__namespace, type: ResizedDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[resized]'
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }, { type: i0__namespace.NgZone }]; }, propDecorators: { resized: [{
                    type: i0.Output
                }] } });

    var AngularResizeEventModule = /** @class */ (function () {
        function AngularResizeEventModule() {
        }
        return AngularResizeEventModule;
    }());
    AngularResizeEventModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.6", ngImport: i0__namespace, type: AngularResizeEventModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    AngularResizeEventModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.6", ngImport: i0__namespace, type: AngularResizeEventModule, declarations: [ResizedDirective], exports: [ResizedDirective] });
    AngularResizeEventModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.6", ngImport: i0__namespace, type: AngularResizeEventModule, imports: [[]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.6", ngImport: i0__namespace, type: AngularResizeEventModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            ResizedDirective
                        ],
                        imports: [],
                        exports: [
                            ResizedDirective
                        ]
                    }]
            }] });

    /*
     * Public API Surface of angular-resize-event
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AngularResizeEventModule = AngularResizeEventModule;
    exports.ResizedDirective = ResizedDirective;
    exports.ResizedEvent = ResizedEvent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=angular-resize-event.umd.js.map
